Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/simplify.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/simplify.cpp	(revision 1007)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/simplify.cpp	(revision 2090)
@@ -9,419 +9,468 @@
 #include "../include/simplify.h"
 #include "../include/saliency.h"
+#include "../include/histogram.h"
 
 //#define RECOMPUTE_THE_WHOLE_HEAP
-//#define MAKE_FULL_COPY
 
 using namespace	VMI;
+using	namespace	std;
+
+//	Multimap to store current vertex in a simplification state.
+typedef	multimap<_float3_,	int>	t_map;
+typedef	t_map::iterator						t_map_str;
+typedef	t_map::value_type					t_pair;
+t_map															mVertexMap;
+multimap<int,int>									mVertices;
+
+vector<Geometry::Vector3>	VMI::vPositions;
+vector<Geometry::Vector3>	VMI::vNormals;
+vector<Geometry::Vector2>	VMI::vTexCoords;
 
 ///////////////////////////////////////////////////////////////////////////////
 
 void VMI::bh_mydump(Mesh *mesh, bheap_t *h) {
-    int i, d;
-
-    printf("Heap status.\n");
-    for(i = 1; i <= h->n; i++) {
-        d = h->a[i].item;
-        printf ("Heap [%d] = pri %f, e%d(%d, %d)\n", i,
-                  h->a[i].key,d,
-                  mesh->edges[d].u,
-                  mesh->edges[d].v);
-    }
-
-    printf("\n");
-    
-    for(i = 2; i <= h->n; i++) {
-        if(h->a[i].key < h->a[i/2].key) {
-            printf("key error at entry %d, value %f\n", i, h->a[i].key);
-            exit(1);
-        }
-    }
-    for(i = 1; i <= h->n; i++) {
-        if(h->p[h->a[i].item] != i) {
-            printf("indexing error at entry %d", i); exit(1);
-        }
-    }    
+	int i, d;
+
+	printf("Heap status.\n");
+	for(i = 1; i <= h->n; i++) {
+		d = h->a[i].item;
+		printf ("Heap [%d] = pri %f, e%d(%d, %d) d:%d\n",
+				i,
+				h->a[i].key,d,
+				mesh->edges[d].u,
+				mesh->edges[d].v, 
+				h->a[i].dirty);
+	}
+	printf("\n");
+
+	for(i = 2; i <= h->n; i++) {
+		if(h->a[i].key < h->a[i/2].key) {
+			printf("key error at entry %d, value %f\n", i, h->a[i].key);
+			exit(1);
+		}
+	}
+	for(i = 1; i <= h->n; i++) {
+		if(h->p[h->a[i].item] != i) {
+			printf("indexing error at entry %d", i);
+			exit(1);
+		}
+	}    
 }
 
 bheap_t *VMI::initHeap(Mesh *mesh) {
-    GLuint i;
-    double cost;
-    bheap_t *h = NULL;
-#ifdef MAKE_FULL_COPY
-    Triangle *triangleCopy = NULL;
-    GLuint lastNumTriangles = mesh->numTriangles;
-
-    // Allocate memory
-    triangleCopy = (Triangle *)malloc(lastNumTriangles * sizeof(Triangle));  
-    if (triangleCopy == NULL) {
-        fprintf(stderr, "Error allocating memory\n");
-        exit(1);
-    }
-    // Make a copy of current triangle list
-    memcpy(triangleCopy, mesh->triangles, lastNumTriangles * sizeof(Triangle));
-#endif
-    
-    printf("Creating a heap for simplification...");
-    
-    h = bh_alloc(mesh->numEdges);
-
-		//	Init percent update count.
-		float	percent	=	60.0 / mesh->numEdges;
-
-    for (i = 0; i <mesh->numEdges; i++) {
-
-				//	Update progress bar.
-				mUPB(percent);
-
-        if (mesh->edges[i].enable == TRUE) {
-
-            cost = computeEdgeCost(mesh, i);
-        
-            // Add only valid edges
-            if (cost != FLT_MAX)
-                bh_insert(h, i, cost);
-
-#ifdef MAKE_FULL_COPY
-            // Restore initial triangle list
-            memcpy(mesh->triangles, triangleCopy, lastNumTriangles * sizeof(Triangle));
-            mesh->numTriangles = lastNumTriangles;
-#endif
-        }
-    }
-    
-#ifdef MAKE_FULL_COPY
-    // Free memory
-    if (triangleCopy != NULL) free(triangleCopy);
-#endif
-    printf("Ok\n");
+	GLuint i;
+	double cost;
+	bheap_t *h = NULL;
+
+	printf("Creating a heap for simplification...");
+
+	h = bh_alloc(mesh->numEdges);
+
+	//	Init percent update count.
+	float	percent	=	60.0 / mesh->numEdges;
+
+	for (i = 0; i <mesh->numEdges; i++) {
+
+		//	Update progress bar.
+		mUPB(percent);
+
+		if (mesh->edges[i].enable == TRUE) {
+
+			cost = computeEdgeCost(mesh, i);
+
+			// Add only valid edges
+			if (cost != FLT_MAX) {
+				bh_insert(h, i, cost);
+				/* set dirty flag to FALSE */
+				bh_mark(h, i, FALSE);
+			}
+		}
+	}
+
+	printf("Ok\n");
 
 #ifdef DEBUG 
-    bh_mydump(mesh, h);
-    //getchar();
-#endif
-
-    return h;
+	bh_mydump(mesh, h);
+	//getchar();
+#endif
+
+	return h;
 }
 
 bheap_t *VMI::updateHeap(bheap_t *h, Mesh *mesh, Change *c) {
-    int e, i, n0, n1, n2, u, v;
+	int e, i;
 #ifdef RECOMPUTE_THE_WHOLE_HEAP
-    bheap_t *nh;
+	bheap_t *nh;
+	double cost;
 #else
-    int *lv, *le, numV, numE;
-#endif
-    double cost;
-#ifdef MAKE_FULL_COPY
-    GLuint lastNumTriangles = mesh->numTriangles;
-    Triangle *triangleCopy = NULL;
-    
-    // Allocate memory
-    triangleCopy = (Triangle *)malloc(lastNumTriangles * sizeof(Triangle));  
-    if (triangleCopy == NULL) {
-        fprintf(stderr, "Error allocating memory\n");
-        exit(1);
-    }
-    // Make a copy of current triangle list
-    memcpy(triangleCopy, mesh->triangles, lastNumTriangles * sizeof(Triangle));
-#endif
-
-    for (i=0; i<c->numDel; i++) {
-
-        n0 = c->deleted[i].indices[0];
-        n1 = c->deleted[i].indices[1];
-        n2 = c->deleted[i].indices[2];
-
-        if (((n0 == c->u) || (n1 == c->u)) &&
-            ((e = findEdge(mesh->edges, mesh->numEdges, n0, n1)) != -1)) {
-
-            mesh->edges[e].enable = FALSE;
-            bh_delete(h, e);
-        }
-
-        if (((n1 == c->u) || (n2 == c->u)) &&
-            ((e = findEdge(mesh->edges, mesh->numEdges, n1, n2)) != -1)) {
-             
-            mesh->edges[e].enable = FALSE;
-            bh_delete(h, e);
-        }
-
-        if (((n0 == c->u) || (n2 == c->u)) &&
-            ((e = findEdge(mesh->edges, mesh->numEdges, n0, n2)) != -1)) {
-              
-            mesh->edges[e].enable = FALSE;
-            bh_delete(h, e);
-        }
-    }
-
-    // Update mesh and heap
-    for(i = 1; i <= h->n; i++) {
-        e = h->a[i].item;
-
-        if ((int)mesh->edges[e].u == c->u)
-            mesh->edges[e].u = c->v;
-
-        if ((int)mesh->edges[e].v == c->u)
-            mesh->edges[e].v = c->v;
-        
-        // Check edge
-        u = mesh->edges[e].u;
-        v = mesh->edges[e].v;
-    
-        // if it is not a valid edge we simply delete it
-        if ((u == v) || 
-            (u == c->u) || (v == c->u)) {
-
-            mesh->edges[e].enable = FALSE;
-            bh_delete(h, e);
-        }
-    }
+	int *lv, *le, numV, numE;
+#endif
 
 #ifdef RECOMPUTE_THE_WHOLE_HEAP
 
-    nh = bh_alloc(mesh->numEdges);
-
-    // Recompute heap
-    for(i = 1; i <= h->n; i++) {
-        e = h->a[i].item;
-        
-        cost = computeEdgeCost(mesh, e);
-        
-        // Add only valid edges
-        if (cost != FLT_MAX)
-            bh_insert(nh, e, cost);
-        
-#ifdef MAKE_FULL_COPY
-        // Restore initial triangle list
-        memcpy(mesh->triangles, triangleCopy, lastNumTriangles * sizeof(Triangle));
-        mesh->numTriangles = lastNumTriangles;
-#endif
-    }
-
-#ifdef MAKE_FULL_COPY
-    // Free memory
-    if (triangleCopy != NULL) free(triangleCopy);
-#endif
-    bh_free(h);
-
-    h = nh;
+	nh = bh_alloc(mesh->numEdges);
+
+	// Recompute heap
+	for(i = 1; i <= h->n; i++) {
+		e = h->a[i].item;
+
+		cost = computeEdgeCost(mesh, e);
+
+		// Add only valid edges
+		if (cost != FLT_MAX)
+			bh_insert(nh, e, cost);
+	}
+
+	bh_free(h);
+
+	h = nh;
 
 #else
 
-    // Compute vertices adjacent to a vertex
-    lv = verticesAdjToVertex(mesh, c->v, &numV);
-
-    // Compute edges adjacent to vertices
-    le = edgesAdjToVertices(mesh, lv, numV, &numE);
-
-    free(lv);
-
-    // Delete adjacent edges from the heap
-    for(i = 0; i <numE; i++) {
-        e = le[i];
-
-        mesh->edges[e].enable = FALSE;
-        bh_delete(h, e);
-    }
-
-    // Recompute cost only for the adjacent edges
-    for(i = 0; i <numE; i++) {
-        e = le[i];
-        
-        cost = computeEdgeCost(mesh, e);
-
-        // Add only valid edges
-        if (cost != FLT_MAX) {
-            bh_insert(h, e, cost);
-            mesh->edges[e].enable = TRUE;
-        }
-        
-#ifdef MAKE_FULL_COPY
-        // Restore initial triangle list
-        memcpy(mesh->triangles, triangleCopy, lastNumTriangles * sizeof(Triangle));
-        mesh->numTriangles = lastNumTriangles;
-#endif
-
-    }
-
-#ifdef MAKE_FULL_COPY
-    // Free memory
-    if (triangleCopy != NULL) free(triangleCopy);
-#endif
-
-    free(le);
+	// Compute vertices adjacent to a vertex
+	lv = verticesAdjToVertex(mesh, c->v, &numV);
+
+	// Compute edges adjacent to vertices
+	le = edgesAdjToVertices(mesh, lv, numV, &numE);
+
+	free(lv);
+
+	// Set a dirty flag to adjacent edges from the heap
+	for(i = 0; i <numE; i++) {
+		e = le[i];
+
+		bh_mark(h, e, TRUE);
+	}
+
+	free(le);
 #endif
 
 #ifdef DEBUG 
-    bh_mydump(mesh, h);
-    //getchar();
-#endif
-
-    return h;
+	bh_mydump(mesh, h);
+	//getchar();
+#endif
+
+	return h;
 }
 
 GLdouble VMI::computeEdgeLength(Vertex *vertices, int u, int v) {
-    GLfloat ux, uy, uz, vx, vy ,vz, rx, ry, rz;
-    
-    ux = vertices[u].x;
-    uy = vertices[u].y;
-    uz = vertices[u].z;
-
-    vx = vertices[v].x;
-    vy = vertices[v].y;
-    vz = vertices[v].z;
-
-    rx = ux - vx;
-    ry = uy - vy;
-    rz = uz - vz;
-
-    return sqrt((rx * rx) + (ry * ry) + (rz * rz));
+	GLfloat ux, uy, uz, vx, vy ,vz, rx, ry, rz;
+
+	ux = vertices[u].x;
+	uy = vertices[u].y;
+	uz = vertices[u].z;
+
+	vx = vertices[v].x;
+	vy = vertices[v].y;
+	vz = vertices[v].z;
+
+	rx = ux - vx;
+	ry = uy - vy;
+	rz = uz - vz;
+
+	return sqrt((rx * rx) + (ry * ry) + (rz * rz));
 }
 
 ///////////////////////////////////////////////////////////////////////////////
 
-void VMI::swap(unsigned int *i, unsigned int *j) {
-    unsigned int t;
-
-    t = *i;
-    *i = *j;
-    *j = t;
-}
-
 void VMI::chooseBestEndPoints(Mesh *mesh, int e) {
-    int v = mesh->edges[e].v;
-    int u = mesh->edges[e].u;
-    int numTu;
-    int *Tu  = trianglesAdjToVertex(mesh, u, &numTu);
-    int numTuv = 0;
-    int *Tuv = (int *)malloc(numTu * sizeof(int));
-    int numTv;
-    int *Tv  = trianglesAdjToVertex(mesh, v, &numTv);
-    int i, j, f, n, n0, n1, n2;
-    float cost_u_v, cost_v_u, mincurve, curve, dot;
-    
-    //printItemList(Tv, numTv);
-    //printItemList(Tu, numTu);
-    
-    // Compute Tuv
-    for (i=0; i<(int)numTu; i++) {
-        
-        n = Tu[i];
-        
-        n0 = mesh->triangles[n].indices[0];
-        n1 = mesh->triangles[n].indices[1];
-        n2 = mesh->triangles[n].indices[2];
-        
-        if ((n0 == v) || (n1 == v) || (n2 == v))
-            
-            Tuv[numTuv++] = n;
-    }
-    //printItemList(Tuv, numTuv);
-    
-    curve = 0.0f;
-    for (i=0; i<numTu; i++) {
-        n = Tu[i];
-        mincurve = 1.0f;
-        for (j=0; j<numTuv; j++) {
-            f = Tuv[j];
-            dot = glmDot(mesh->triangles[f].normal, mesh->triangles[n].normal);
-            //printf("dot: %f \n", dot);
-            mincurve = MIN(mincurve, (1.0f - dot) / 2.0f);
-        }
-        //printf("mincurve: %f \n", mincurve);
-        curve = MAX(curve, mincurve);
-    }
-    cost_u_v = curve;
-    
-    curve = 0.0f;
-    for (i=0; i<numTv; i++) {
-        n = Tv[i];
-        mincurve = 1.0f;
-        for (j=0; j<numTuv; j++) {
-            f = Tuv[j];
-            dot = glmDot(mesh->triangles[f].normal, mesh->triangles[n].normal);
-            //printf("%f \n", dot);
-            mincurve = MIN(mincurve, (1.0f - dot) / 2.0f);
-        }
-        curve = MAX(curve, mincurve);
-    }
-    cost_v_u = curve;
-    
-    //printf("e%d(%d,%d) cost: %f \n", e, u, v, cost_u_v);
-    //printf("e%d(%d,%d) cost: %f \n", e, v, u, cost_v_u);
-    
-    if ( (cost_v_u + 0.000001) < cost_u_v) {
-        //printf("Swap edge\n");
-        //printf("e%d(%d,%d) cost: %f \n", e, u, v, cost_u_v);
-        //printf("e%d(%d,%d) cost: %f \n", e, v, u, cost_v_u);
-        swap(&mesh->edges[e].u, &mesh->edges[e].v);
-    }
-
-    free(Tuv);
-    free(Tu);
-    free(Tv);
+	int v = mesh->edges[e].v;
+	int u = mesh->edges[e].u;
+	int numTu = mesh->vertices[u].numTriangles;
+	int numTuv = 0;
+	int *Tuv = (int *)malloc(numTu * sizeof(int));
+	int i, j, f, n, n0, n1, n2;
+	float cost_u_v, cost_v_u, mincurve, curve, dot;
+
+	// Compute Tuv
+	for (i=0; i<(int)numTu; i++) {
+
+		n = mesh->vertices[u].triangles[i];
+
+		n0 = mesh->triangles[n].indices[0];
+		n1 = mesh->triangles[n].indices[1];
+		n2 = mesh->triangles[n].indices[2];
+
+		if ((n0 == v) || (n1 == v) || (n2 == v))
+
+			Tuv[numTuv++] = n;
+	}
+	//printItemList(Tuv, numTuv);
+
+	curve = 0.0f;
+	for (i=0; i<numTu; i++) {
+		n = mesh->vertices[u].triangles[i];
+		mincurve = 1.0f;
+		for (j=0; j<numTuv; j++) {
+			f = Tuv[j];
+			dot = glmDot(mesh->triangles[f].normal, mesh->triangles[n].normal);
+			//printf("dot: %f \n", dot);
+			mincurve = MIN(mincurve, (1.0f - dot) / 2.0f);
+		}
+		//printf("mincurve: %f \n", mincurve);
+		curve = MAX(curve, mincurve);
+	}
+	cost_u_v = curve;
+
+	curve = 0.0f;
+	for (i=0; i<(int)mesh->vertices[v].numTriangles; i++) {
+		n = mesh->vertices[v].triangles[i];
+		mincurve = 1.0f;
+		for (j=0; j<numTuv; j++) {
+			f = Tuv[j];
+			dot = glmDot(mesh->triangles[f].normal, mesh->triangles[n].normal);
+			//printf("%f \n", dot);
+			mincurve = MIN(mincurve, (1.0f - dot) / 2.0f);
+		}
+		curve = MAX(curve, mincurve);
+	}
+
+	cost_v_u = curve;
+
+	//printf("e%d(%d,%d) cost: %f \n", e, u, v, cost_u_v);
+	//printf("e%d(%d,%d) cost: %f \n", e, v, u, cost_v_u);
+
+	if ( (cost_v_u + 0.000001) < cost_u_v) {
+		//printf("Swap edge\n");
+		//printf("e%d(%d,%d) cost: %f \n", e, u, v, cost_u_v);
+		//printf("e%d(%d,%d) cost: %f \n", e, v, u, cost_v_u);
+		
+		swap((int *)&mesh->edges[e].u, (int *)&mesh->edges[e].v);
+	}
+
+	free(Tuv);
 }
 ///////////////////////////////////////////////////////////////////////////////
 
+void saveProjectedAreas(GLuint **histogram, GLuint numCameras, Change *c, GLuint *dest) {
+	GLuint i, j, t, n = 0;
+
+	for (j=0; j<(GLuint)c->numDel; j++) {
+
+		t = c->deleted[j].id;
+
+		for (i=0; i<numCameras; i++) {
+
+			dest[n] = histogram[i][t + 1];
+			n++;
+		}
+	}
+
+	for (j=0; j<(GLuint)c->numMod; j++) { 
+
+		t = c->modified[j].id;
+
+		for (i=0; i<numCameras; i++) {
+
+			dest[n] = histogram[i][t + 1];
+			n++;
+		}   
+	}
+
+	// Save background area
+	for (i=0; i<numCameras; i++) {
+
+		dest[n] = histogram[i][0];
+		n++;
+	}
+}
+
+void loadProjectedAreas(GLuint *src, GLuint numCameras, Change *c, GLuint **histogram) {
+	GLuint i, j, t, n = 0;
+
+	for (j=0; j<(GLuint)c->numDel; j++) { 
+
+		t = c->deleted[j].id;
+
+		for (i=0; i<numCameras; i++) {
+
+			histogram[i][t + 1] = src[n];
+			n++;
+		}
+	}
+
+	for (j=0; j<(GLuint)c->numMod; j++) { 
+
+		t = c->modified[j].id;
+
+		for (i=0; i<numCameras; i++) {
+
+			histogram[i][t + 1] = src[n];
+			n++;
+		}
+	}
+
+	// Load background area
+	for (i=0; i<numCameras; i++) {
+
+		histogram[i][0] = src[n];
+		n++;
+	}
+}
+
+///////////////////////////////////////////////////////////////////////////////
+
 GLdouble VMI::computeEdgeCost(Mesh *mesh, int e) {
-    GLdouble cost = 0.0, newI, sal = 1.0, /*length,*/ error;
-    GLuint i;
-    Change *c;
-
-    chooseBestEndPoints(mesh, e);
-    //getchar();
-
-    c = createChange(mesh, e);
-    
+	GLdouble cost = 0.0, sal = 1.0;
+#ifdef MI
+	GLdouble *auxIs = NULL;
+#else
+	GLdouble newI;
+#endif
+	GLuint i, *histoAux = NULL;
+	Change *c;
+
+	chooseBestEndPoints(mesh, e);
+	//getchar();
+
+	c = createChange(mesh, e);
+
+	// Compute cost only for boundary or manifold edges
+	if (c->numDel == 2
+			/*(c->numDel <3) && (c->numDel > 0)*/) {
+		// Allocate memory
+		histoAux = (GLuint *)malloc((c->numDel + c->numMod + 1) * numCameras * sizeof(GLuint));
+
+#ifdef MI // Mutual Information
+		///////////////////////////////////////////////////////////////////////////////
+		// Allocate memory
+		auxIs = (GLdouble *)malloc(numCameras * sizeof(GLdouble));
+
+		//printFullHistogram(histogram, numCameras, mesh->numTriangles);
+
+		for (i=0; i<numCameras; i++) {
+			// Copy old informations
+			auxIs[i] = initialIs[i];
+
+			initialIs[i] = decMI(initialIs[i], histogram, numCameras, i, c);
+		}
+
+		saveProjectedAreas(histogram, numCameras, c, histoAux);
     // Apply the edge collapse
-    computeChanges(mesh, c);
-    
-    // Compute cost only for boundary or manifold edges
-    if ((c->numDel <3) && (c->numDel > 0)) {
-
-        //length = computeEdgeLength(mesh->vertices, c->u, c->v);
-
-        doChange(mesh, c);
-        
-        // Compute the cost of an edge collapse
-        getProjectedAreas(histogram, numCameras);
-        //printFullHistogram(histogram, numCameras, mesh->numTriangles);
-        //getchar();
+		doChange(mesh, c);
+
+		// Compute the cost of an edge collapse
+		getProjectedAreasWin(histogram, numCameras, c);
+		//printFullHistogram(histogram, numCameras, mesh->numTriangles);
+		//getchar();
+
 #ifdef SALIENCY
-        sal = computeEdgeSaliency(mesh, c, percentile);
-        //printf("  e:%d s: %f\n", c->e, sal);
-#endif
-        for (i=0;i <numCameras; i++) {
+		sal = computeEdgeSaliency(mesh, c, percentile);
+		//printf("  e:%d s: %f\n", c->e, sal);
+#endif
+
+		for (i=0; i<numCameras; i++) {
+
+			initialIs[i] = incMI(initialIs[i], histogram, numCameras, i, c);
+			//printf("  I0:%f Is: %f\n", auxE[i], initialIs[i]);
+
+			cost += (ABS(auxIs[i] - initialIs[i]) * cameras[i].weight * sal);
+
+			// Restore old informations
+			initialIs[i] = auxIs[i];
+		}
+
+		undoChange(mesh, c);
+
+		loadProjectedAreas(histoAux, numCameras, c, histogram);
+		//printFullHistogram(histogram, numCameras, mesh->numTriangles);
+		//exit(1);
+
+		// Free memory
+		free(auxIs);
+#else
+		///////////////////////////////////////////////////////////////////////////////
+
+		saveProjectedAreas(histogram, numCameras, c, histoAux);
+
+		doChange(mesh, c);
+
+		// Compute the cost of an edge collapse
+		getProjectedAreasWin(histogram, numCameras, c);
+		//printFullHistogram(histogram, numCameras, mesh->numTriangles);
+
+#ifdef SALIENCY
+		sal = computeEdgeSaliency(mesh, c, percentile);
+		//printf("  e:%d s: %f\n", c->e, sal);
+#endif
+		for (i=0;i <numCameras; i++) {
 
 #ifdef KL // Kullback-Leibler
-            newI = computeKL(mesh, histogram[i]);
-#endif
-#ifdef MI // Mutual Information
-            newI = computeMI(mesh, histogram, numCameras, i);
+			newI = computeKL(mesh, histogram[i]);
 #endif
 #ifdef HE // Hellinger
-            newI = computeHE(mesh, histogram[i]);
+			newI = computeHE(mesh, histogram[i]);
 #endif
 #ifdef CS // Chi-Square
-            newI = computeCS(mesh, histogram[i]);
-#endif
-
-            error = ABS(initialIs[i] - newI);
-            
-            if (error > 0.0) 
-                cost += ((error * cameras[i].weight * sal) /*+ (length * 0.05)*/);
-        }
-
-        undoChange(mesh, c);
-
-    } else cost = FLT_MAX;
-
-
-    deleteChange(c);
-
-    return cost;
-}
-
-///////////////////////////////////////////////////////////////////////////////
-
+			newI = computeCS(mesh, histogram[i]);
+#endif
+			cost += (ABS(initialIs[i] - newI) * cameras[i].weight * sal);
+		}
+		undoChange(mesh, c);
+
+		loadProjectedAreas(histoAux, numCameras, c, histogram);
+		//printFullHistogram(histogram, numCameras, mesh->numTriangles);
+		//exit(1);
+
+		///////////////////////////////////////////////////////////////////////////////
+#endif
+		// Free memory
+		free(histoAux);
+
+	} else cost = FLT_MAX;
+
+	deleteChange(c);
+
+	return cost;
+}
+/* Get a valid edge from the heap */
+int getMinValidEdge(Mesh *mesh, bheap_t *h) {
+	int e;
+
+	/* pick the minimum-cost valid edge from heap */
+	e = bh_min(h);
+
+	while (mesh->edges[e].enable == FALSE) {
+		/* delete invalid edge */
+		bh_delete(h, e);
+		/* pick again*/
+		e = bh_min(h);
+	}
+
+	return e;
+}
+
+/* Get the mininum edge cost from the heap using lazy evaluation */
+int getMinEdge(Mesh *mesh, bheap_t *h) {
+	double cost;
+	int e;
+
+	/* pick the minimum-cost edge from heap */
+	e = getMinValidEdge(mesh, h);
+
+	while (bh_is_dirty(h, e)) {
+		/* delete edge from heap */
+		bh_delete(h, e);
+		mesh->edges[e].enable = FALSE;
+		/* recompute cost*/
+		cost = computeEdgeCost(mesh, e);
+
+		// Add only valid edges
+		if (cost != FLT_MAX) {
+			/* reinsert into the heap */
+			bh_insert(h, e, cost);
+			mesh->edges[e].enable = TRUE;
+			/* set dirty flag to FALSE */
+			bh_mark(h, e, FALSE);
+		}
+
+		/* pick again */
+		e = getMinValidEdge(mesh, h);
+	}
+
+	return e;
+}
+
+///////////////////////////////////////////////////////////////////////////
 void VMI::simplifyModel(Mesh *mesh, GLuint numDemandedTri)
 {
@@ -444,29 +493,7 @@
 	{
 #ifdef SALIENCY       
-#ifdef KL // Kullback-Leibler
-		sprintf(s,"%s_VKL_S.log", filename);
-#endif
-#ifdef MI // Mutual Information
-		sprintf(s,"%s_VMI_S.log", filename);
-#endif
-#ifdef HE // Hellinger
-		sprintf(s,"%s_VHE_S.log", filename);
-#endif
-#ifdef CS // Chi-Square
-		sprintf(s,"%s_VCS_S.log", filename);
-#endif
+		sprintf(s,"%s_%s_S.log", filename, EXT);
 #else
-#ifdef KL // Kullback-Leibler
-		sprintf(s,"%s_VKL.log", filename);
-#endif
-#ifdef MI // Mutual Information
-		sprintf(s,"%s_VMI.log", filename);
-#endif
-#ifdef HE // Hellinger
-		sprintf(s,"%s_VHE.log", filename);
-#endif
-#ifdef CS // Chi-Square
-		sprintf(s,"%s_VCS.log", filename);
-#endif
+		sprintf(s,"%s_%s.log", filename, EXT);
 #endif
 
@@ -475,5 +502,5 @@
 		/* open the file */
 		file = fopen(s, "a+");
-		
+
 		if (!file)
 		{
@@ -485,12 +512,12 @@
 	//	Open file of simplification sequence.
 	file_simp_seq	=	fopen("SimplifSequence.txt", "w");
-	
+
 	if (!file_simp_seq)
 	{
 		fprintf(stderr,
-						"simplifyModel() failed: ",
-						"can't open file \"SimplifSequence\" to write.\n");
-	}
-	
+				"simplifyModel() failed: ",
+				"can't open file \"SimplifSequence\" to write.\n");
+	}
+
 	h = initHeap(mesh);
 
@@ -500,29 +527,33 @@
 	{
 		// Get the edge that has the minimum cost
-		e = bh_min(h);
+		//e = getMinEdge(mesh, h);
+		e = extractValidEdge(mesh, h);
 
 		c = createChange(mesh, e);
 
 		// Apply the edge collapse
-		computeChanges(mesh, c);
 		doChange(mesh, c);
+		//deleteVertexOfMap(mesh, c->u);
+
+		// Write Simplification sequence.
+		saveSimplificationSequence(c,0);
+
+		//contractTwinVertices(mesh, c->u, c->v); // vertex u is removed
 
 		if (bSaveLog == TRUE) writeChange(file, c);
 
-		//	Write Simplification sequence.
-		saveSimplificationSequence(c);
-		
 		cost = h->a[h->p[e]].key;
-		
+
+		/*
 		printf(	"Edge collapse e%d(%d,%d) %f MIN d %d m %d\n",
-						c->e,
-						c->u,
-						c->v,
-						cost,
-						c->numDel,
-						c->numMod);
+				c->e,
+				c->u,
+				c->v,
+				cost,
+				c->numDel,
+				c->numMod);
+		*/
 
 		mesh->edges[e].enable = FALSE;
-		
 		bh_delete(h, e);
 
@@ -532,4 +563,7 @@
 		computeCameraIs(histogram, numCameras, initialIs);
 
+		deleteEdges(mesh, c);
+		modifyEdges(mesh, c);
+
 		// Update the heap according to the edge collapse
 		h = updateHeap(h, mesh, c);
@@ -539,6 +573,11 @@
 		deleteChange(c);
 
-		printf("t %d\n", mesh->currentNumTriangles);
-	}
+		//printf("t %d\n", mesh->currentNumTriangles);
+	}
+
+	//	Debug.
+	cout	<<	"Number of vertices: "
+		<<	mesh->currentNumVertices
+		<<	endl;
 
 	if (bSaveLog == TRUE)
